# on définit l'exponentielle
# de 3 façons, dans la dernière
# on minimise le nombre de produits effectués

# version non récursive, simplement itérative
def exp_iter(a,n):
    temp=1
    # si n==0, on ne rentre pas dans la boucle
    for i in range(0,n):
        temp*=a
    return temp

# version récursive
def slow_exp(a,n):
    # on affiche les appels réalisés
    print("appel à slow_exp(",a,",",n,")")
    if n==0:
        print("renvoie 1")
        return 1
    else:
        calcul=a*slow_exp(a,n-1)
        print("renvoie",calcul)
        return calcul

# version récursive, on veut
# élever au carré le plus souvent possible
def fast_exp(a,n):
    print("appel à fast_exp(",a,",",n,")")
    if n==0:
        print("renvoie 1")
        return 1
    elif n%2==0:
        calcul=fast_exp(a**2,n//2)
        print("renvoie",calcul)
        return calcul
    else:
        calcul=a*fast_exp(a**2,(n-1)//2)
        print("renvoie",calcul)
        return calcul

print(exp_iter(2,13))
print(slow_exp(2,13))
print(fast_exp(2,13))